﻿Imports System.Data.OleDb
Imports C1.Win.C1FlexGrid

Public Class Form1

    Private Shared Function GetConnectionString() As String
        Dim path As String = Environment.GetFolderPath(Environment.SpecialFolder.Personal) + "\ComponentOne Samples\Common"
        Dim conn As String = "provider=microsoft.jet.oledb.4.0;data source={0}\c1nwind.mdb;"
        Return String.Format(conn, path)
    End Function
    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Panel1.AllowDrop = True
        Dim conn As String = GetConnectionString()
        Dim rs As String = "select * from customers"
        Dim da As New OleDbDataAdapter(rs, conn)
        Dim dt As New DataTable()
        da.Fill(dt)
        C1FlexGrid1.DataSource = dt
    End Sub

    Private Sub c1FlexGrid1_MouseDown(sender As Object, e As MouseEventArgs) Handles C1FlexGrid1.MouseDown
        Dim hti As HitTestInfo = C1FlexGrid1.HitTest(e.X, e.Y)
        If hti.Type = HitTestTypeEnum.ColumnHeader Then
            C1FlexGrid1.DoDragDrop(C1FlexGrid1.Cols(hti.Column).Name, DragDropEffects.Copy)
        End If

    End Sub

    Private Sub panel1_DragEnter(sender As Object, e As DragEventArgs) Handles Panel1.DragEnter
        If (e.AllowedEffect And DragDropEffects.Copy) = DragDropEffects.Copy AndAlso e.Data.GetDataPresent(GetType(String)) Then
            e.Effect = DragDropEffects.Copy
        End If
    End Sub

    Private Sub panel1_DragDrop(sender As Object, e As DragEventArgs) Handles Panel1.DragDrop
        If e.Effect = DragDropEffects.Copy Then
            Dim btn As New Button()
            btn.Text = DirectCast(e.Data.GetData(GetType(String)), String)
            btn.Location = Me.PointToClient(New Point(e.X, e.Y))
            Me.Controls.Add(btn)
            btn.BringToFront()
        End If

    End Sub


End Class
